
set echo on

CREATE TABLE trades
( trade_id           NUMBER
, product_type       VARCHAR2(10)
, counterparty       VARCHAR2(30)
, trade_timestamp    TIMESTAMP
, trading_book       VARCHAR2(30)
, maturity_date      DATE
, CONSTRAINT trades_pk 
     PRIMARY KEY (trade_id)
)
PARALLEL;

CREATE TABLE trade_legs
( trade_id           NUMBER
, leg_no             NUMBER
, trade_amount       NUMBER
, currency           VARCHAR2(3)
, trade_price        NUMBER
, CONSTRAINT trade_legs_pk
     PRIMARY KEY (trade_id, leg_no)
, CONSTRAINT trade_legs_fk01
     FOREIGN KEY (trade_id)
     REFERENCES trades (trade_id)
)
PARALLEL;

CREATE TABLE leg_valuations
( trade_id           NUMBER
, leg_no             NUMBER
, valuation_date     DATE
, market_value       NUMBER
, CONSTRAINT leg_valuations_pk
     PRIMARY KEY (trade_id, leg_no, valuation_date)
, CONSTRAINT leg_valuations_fk01
     FOREIGN KEY (trade_id, leg_no)
     REFERENCES trade_legs (trade_id, leg_no)
)
PARALLEL;


