
set echo on
col record_value format a70
col record_type format a20
col trade_rec format a30 heading "TRADE_REC"
col trade_leg_rec format a30 heading "TRADE_LEG_REC"
col leg_valuation_rec format a30 heading "LEG_VALUATION_REC"
set lines 175

SELECT *
FROM   TABLE(
          trades_load.trades_transform(
             CURSOR( SELECT * FROM trades_staging ) ) )
WHERE  ROWNUM <= 5;

SELECT VALUE(nt)
FROM   TABLE(
          trades_load.trades_transform(
             CURSOR( SELECT * FROM trades_staging ) ) ) nt
WHERE  ROWNUM <= 5;

SELECT VALUE(nt) AS record_value
,      CASE
          WHEN VALUE(nt) IS OF TYPE (trade_ot)
          THEN 'TRADES'
          WHEN VALUE(nt) IS OF TYPE (trade_leg_ot)
          THEN 'TRADE_LEGS'
          ELSE 'LEG_VALUATIONS'
       END AS record_type
FROM   TABLE(
          trades_load.trades_transform(
             CURSOR( SELECT * FROM trades_staging ) ) ) nt
WHERE  ROWNUM <= 5;

SELECT CASE
          WHEN VALUE(nt) IS OF TYPE (trade_ot)
          THEN 'TRADES'
          WHEN VALUE(nt) IS OF TYPE (trade_leg_ot)
          THEN 'TRADE_LEGS'
          ELSE 'LEG_VALUATIONS'
       END AS record_type
,      TREAT(VALUE(nt) AS trade_ot)         AS trade_rec
,      TREAT(VALUE(nt) AS trade_leg_ot)     AS trade_leg_rec
,      TREAT(VALUE(nt) AS leg_valuation_ot) AS leg_valuation_rec
FROM   TABLE(
          trades_load.trades_transform(
             CURSOR( SELECT * FROM trades_staging ) ) ) nt
WHERE  ROWNUM <= 5;


SELECT ilv.record_type
,      ilv.trade_rec.transaction_id         AS trade_id
,      ilv.trade_rec.product_type           AS product_type
,      ilv.trade_leg_rec.leg_no             AS leg_no
,      ilv.leg_valuation_rec.valuation_date AS valuation_date
FROM (
      SELECT CASE
                WHEN VALUE(nt) IS OF TYPE (trade_ot)
                THEN 'TRADES'
                WHEN VALUE(nt) IS OF TYPE (trade_leg_ot)
                THEN 'TRADE_LEGS'
                ELSE 'LEG_VALUATIONS'
             END AS record_type
      ,      TREAT(VALUE(nt) AS trade_ot)         AS trade_rec
      ,      TREAT(VALUE(nt) AS trade_leg_ot)     AS trade_leg_rec
      ,      TREAT(VALUE(nt) AS leg_valuation_ot) AS leg_valuation_rec
      FROM   TABLE(
                trades_load.trades_transform(
                   CURSOR( SELECT * FROM trades_staging ) ) ) nt
      WHERE  ROWNUM <= 5
     ) ilv;


